ProxyErrorReportValve (Apache Tomcat 11.0.23 API Documentation)
Description: declaration: package: org.apache.catalina.valves, class: ProxyErrorReportValve

# Class ProxyErrorReportValve

java.lang.Object
org.apache.catalina.util.LifecycleBase
org.apache.catalina.util.LifecycleMBeanBase
org.apache.catalina.valves.ValveBase
org.apache.catalina.valves.ErrorReportValve
org.apache.catalina.valves.ProxyErrorReportValve

All Implemented Interfaces:
  `MBeanRegistration, Contained, JmxEnabled, Lifecycle, Valve`

public class ProxyErrorReportValve extends ErrorReportValve

Implementation of a Valve that proxies or redirects error reporting to other urls.

This Valve should be attached at the Host level, although it will work if attached to a Context.

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from interface Lifecycle

  `Lifecycle.SingleUse`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected boolean`
  `usePropertiesFile`
  Use a properties file for the URLs.
  `protected boolean`
  `useRedirect`
  Use a redirect or proxy the response to the specified location.

  ### Fields inherited from class ValveBase

  `asyncSupported, container, containerLog, next, sm`

  ### Fields inherited from interface Lifecycle

  `AFTER_DESTROY_EVENT, AFTER_INIT_EVENT, AFTER_START_EVENT, AFTER_STOP_EVENT, BEFORE_DESTROY_EVENT, BEFORE_INIT_EVENT, BEFORE_START_EVENT, BEFORE_STOP_EVENT, CONFIGURE_START_EVENT, CONFIGURE_STOP_EVENT, PERIODIC_EVENT, START_EVENT, STOP_EVENT`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ProxyErrorReportValve()`
  Default constructor.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `getUsePropertiesFile()`
  Returns whether a properties file is used to determine the redirect URLs.
  `boolean`
  `getUseRedirect()`
  Returns whether a redirect is used to send the error report to the specified location.
  `protected void`
  `report(Request request, Response response, Throwable throwable)`
  Reports the error by redirecting or proxying to the configured error URL.
  `void`
  `setUsePropertiesFile(boolean usePropertiesFile)`
  Sets whether to use a properties file for the redirect URLs.
  `void`
  `setUseRedirect(boolean useRedirect)`
  Sets whether to use a redirect or proxy for the error report.

  ### Methods inherited from class ErrorReportValve

  `findErrorPage, getPartialServletStackTrace, getProperty, invoke, isShowReport, isShowServerInfo, setProperty, setShowReport, setShowServerInfo`

  ### Methods inherited from class ValveBase

  `backgroundProcess, getContainer, getDomainInternal, getNext, getObjectNameKeyProperties, initInternal, isAsyncSupported, setAsyncSupported, setContainer, setNext, startInternal, stopInternal, toString`

  ### Methods inherited from class LifecycleMBeanBase

  `destroyInternal, getDomain, getObjectName, postDeregister, postRegister, preDeregister, preRegister, register, setDomain, unregister, unregister`

  ### Methods inherited from class LifecycleBase

  `addLifecycleListener, destroy, findLifecycleListeners, fireLifecycleEvent, getState, getStateName, getThrowOnFailure, init, removeLifecycleListener, setState, setState, setThrowOnFailure, start, stop`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### useRedirect

    protected boolean useRedirect
    Use a redirect or proxy the response to the specified location. Default to not redirect.

  - ### usePropertiesFile

    protected boolean usePropertiesFile
    Use a properties file for the URLs.

- ## Constructor Details

  - ### ProxyErrorReportValve

    public ProxyErrorReportValve()
    Default constructor.

- ## Method Details

  - ### getUseRedirect

    public boolean getUseRedirect()
    Returns whether a redirect is used to send the error report to the specified location.
    Returns:
      `true` if a redirect is used, `false` if a proxy is used

  - ### setUseRedirect

    public void setUseRedirect(boolean useRedirect)
    Sets whether to use a redirect or proxy for the error report.
    Parameters:
      `useRedirect` - `true` to use a redirect, `false` to use a proxy

  - ### getUsePropertiesFile

    public boolean getUsePropertiesFile()
    Returns whether a properties file is used to determine the redirect URLs.
    Returns:
      `true` if a properties file is used, `false` otherwise

  - ### setUsePropertiesFile

    public void setUsePropertiesFile(boolean usePropertiesFile)
    Sets whether to use a properties file for the redirect URLs.
    Parameters:
      `usePropertiesFile` - `true` to use a properties file, `false` otherwise

  - ### report

    protected void report(Request request, Response response, Throwable throwable)
    Reports the error by redirecting or proxying to the configured error URL.
    Overrides:
      `report` in class `ErrorReportValve`
    Parameters:
      `request` - the servlet request
      `response` - the servlet response
      `throwable` - the exception that caused the error, or `null`